/*-
 * Copyright (C)2007 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2007 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: bits.c,v 1.4 2007/11/22 00:41:35 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sys/event.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <mife.h>
#include <err.h>
#include <multilar.h>
#include <babolo/parser.h>
#include <babolo/BLINflag.h>
#include "popushd.h"

u_char *
createbit(size_t n) {
    return(calloc((n + 7) >> 3, 1));
}

void
set(u_char *b, size_t n) {
    size_t i = n >> 3;
    u_char j = 1 << (n & 7);
    b[i] |= j;
}

void
bitset(u_char *b, u_char *c, size_t n) {
    size_t i, l = (n + 7) >> 3;
    for (i = 0; i < l; i++) b[i] |= c[i];
}

void
setact(popush_main *r, size_t a) {
    u_char *clusterbit;

    if  (!(clusterbit = mular_getix(r->cnf->ask, a))) {
        mesg(r->flags, DE("mular_getix setaction %u"), a);
    } else {
        bitset(r->actionbit, clusterbit, MULAR_NEXT(r->cnf->cluster));
}   }

void
setaction(popush_main *r, size_t a) {
    if  (a) setact(r, a);
}
